diff --git a/gdb/testsuite/gdb.arch/powerpc-power.exp b/gdb/testsuite/gdb.arch/powerpc-power.exp
index 530dc81..2f2c39f 100644
--- a/gdb/testsuite/gdb.arch/powerpc-power.exp
+++ b/gdb/testsuite/gdb.arch/powerpc-power.exp
@@ -181,3 +181,138 @@ func_check +448  "ddiv    f1,f2,f1"
 func_check +452  "ddivq   f0,f2,f0"
 func_check +456  "dcmpu   cr1,f2,f1"
 func_check +460  "dcmpuq  cr1,f2,f0"
+func_check +464  "tabort. r5"
+func_check +468  "tabortwc. 7,r8,r16"
+func_check +472  "tabortdc. 20,r11,r10"
+func_check +476  "tabortwci. 17,r10,-13"
+func_check +480  "tabortdci. 29,r3,-5"
+func_check +484  "tbegin."
+func_check +488  "tcheck  cr7"
+func_check +492  "tend."
+func_check +496  "tendall."
+func_check +500  "treclaim. r24"
+func_check +504  "trechkpt."
+func_check +508  "tsuspend."
+func_check +512  "tresume."
+func_check +516  "rfebb"
+func_check +520  "rfebb   1"
+func_check +524  "bctar-  12,4\\*cr5\\+gt"
+func_check +528  "bctarl- 4,4\\*cr1\\+so"
+func_check +532  "bctar\\+  12,4\\*cr3\\+lt"
+func_check +536  "bctarl\\+ 4,eq"
+func_check +540  "bctar   4,4\\*cr2\\+lt,1"
+func_check +544  "bctarl  4,4\\*cr1\\+so,2"
+func_check +548  "waitasec"
+func_check +552  "msgsndp r8"
+func_check +556  "mtsle   1"
+func_check +560  "msgclrp r27"
+func_check +564  "stqcx.  r10,r10,r12"
+func_check +568  "stqcx.  r28,0,r7"
+func_check +572  "lqarx   r24,r19,r11"
+func_check +576  "lqarx   r22,0,r11"
+func_check +580  "mfbhrbe r20,6"
+func_check +584  "pbt.    r29,r17,r16"
+func_check +588  "pbt.    r14,0,r7"
+func_check +592  "clrbhrb"
+func_check +596  "vpermxor v11,v10,v0,v23"
+func_check +600  "vaddeuqm v24,v2,v7,v4"
+func_check +604  "vaddecuq v10,v10,v8,v2"
+func_check +608  "vsubeuqm v5,v15,v8,v19"
+func_check +612  "vsubecuq v12,v31,v16,v29"
+func_check +616  "vmulouw v20,v29,v13"
+func_check +620  "vmuluwm v29,v0,v26"
+func_check +624  "vaddudm v8,v21,v28"
+func_check +628  "vmaxud  v1,v26,v1"
+func_check +632  "vrld    v20,v3,v1"
+func_check +636  "vcmpequd v4,v19,v11"
+func_check +640  "vadduqm v23,v14,v30"
+func_check +644  "vaddcuq v8,v8,v13"
+func_check +648  "vmulosw v28,v27,v4"
+func_check +652  "vmaxsd  v3,v4,v4"
+func_check +656  "vmuleuw v0,v19,v21"
+func_check +660  "vminud  v24,v20,v19"
+func_check +664  "vcmpgtud v0,v28,v15"
+func_check +668  "vmulesw v21,v0,v2"
+func_check +672  "vminsd  v9,v26,v9"
+func_check +676  "vsrad   v25,v29,v11"
+func_check +680  "vcmpgtsd v11,v28,v11"
+func_check +684  "bcdadd. v5,v8,v26,1"
+func_check +688  "vpmsumb v4,v3,v12"
+func_check +692  "bcdsub. v26,v31,v21,1"
+func_check +696  "vpmsumh v5,v17,v16"
+func_check +700  "vpkudum v23,v17,v20"
+func_check +704  "vpmsumw v24,v21,v29"
+func_check +708  "vpmsumd v9,v22,v13"
+func_check +712  "vpkudus v18,v19,v18"
+func_check +716  "vsubuqm v30,v16,v22"
+func_check +720  "vcipher v14,v11,v7"
+func_check +724  "vcipherlast v10,v2,v22"
+func_check +728  "vgbbd   v23,v13"
+func_check +732  "vsubcuq v16,v25,v16"
+func_check +736  "vorc    v31,v1,v5"
+func_check +740  "vncipher v4,v17,v31"
+func_check +744  "vncipherlast v24,v2,v27"
+func_check +748  "vbpermq v23,v21,v23"
+func_check +752  "vpksdus v27,v18,v9"
+func_check +756  "vnand   v27,v29,v27"
+func_check +760  "vsld    v19,v19,v24"
+func_check +764  "vsbox   v5,v13"
+func_check +768  "vpksdss v25,v3,v7"
+func_check +772  "vcmpequd. v28,v8,v0"
+func_check +776  "vupkhsw v26,v26"
+func_check +780  "vshasigmaw v5,v7,0,6"
+func_check +784  "veqv    v28,v21,v14"
+func_check +788  "vmrgow  v1,v8,v19"
+func_check +792  "vshasigmad v0,v10,0,10"
+func_check +796  "vsrd    v5,v27,v14"
+func_check +800  "vupklsw v11,v13"
+func_check +804  "vclzb   v14,v16"
+func_check +808  "vpopcntb v20,v27"
+func_check +812  "vclzh   v28,v11"
+func_check +816  "vpopcnth v24,v9"
+func_check +820  "vclzw   v27,v31"
+func_check +824  "vpopcntw v17,v19"
+func_check +828  "vclzd   v12,v29"
+func_check +832  "vpopcntd v23,v22"
+func_check +836  "vcmpgtud. v24,v20,v29"
+func_check +840  "vcmpgtsd. v9,v6,v27"
+func_check +844  "lxsiwzx vs62,r14,r26"
+func_check +848  "lxsiwzx vs40,0,r25"
+func_check +852  "lxsiwax vs25,0,r26"
+func_check +856  "lxsiwax vs3,0,r3"
+func_check +860  "mfvsrd  r12,vs62"
+func_check +864  "mffprwz r20,f12"
+func_check +868  "stxsiwx vs14,r9,r14"
+func_check +872  "stxsiwx vs21,0,r8"
+func_check +876  "mtvsrd  vs48,r11"
+func_check +880  "mtvrwa  v31,r23"
+func_check +884  "mtfprwz f16,r26"
+func_check +888  "lxsspx  vs13,r19,r13"
+func_check +892  "lxsspx  vs18,0,r13"
+func_check +896  "stxsspx vs43,r2,r4"
+func_check +900  "stxsspx vs55,0,r11"
+func_check +904  "xsaddsp vs54,vs48,vs25"
+func_check +908  "xsmaddasp vs14,vs50,vs1"
+func_check +912  "xssubsp vs26,vs22,vs42"
+func_check +916  "xsmaddmsp vs27,vs53,vs52"
+func_check +920  "xsrsqrtesp vs8,vs59"
+func_check +924  "xssqrtsp vs12,vs41"
+func_check +928  "xsmulsp vs57,vs11,vs32"
+func_check +932  "xsmsubasp vs38,vs20,vs26"
+func_check +936  "xsdivsp vs26,vs19,vs6"
+func_check +940  "xsmsubmsp vs35,vs37,vs55"
+func_check +944  "xsresp  vs59,vs8"
+func_check +948  "xsnmaddasp vs44,vs33,vs33"
+func_check +952  "xsnmaddmsp vs17,vs62,vs30"
+func_check +956  "xsnmsubasp vs54,vs52,vs31"
+func_check +960  "xsnmsubmsp vs37,vs5,vs58"
+func_check +964  "xxlorc  vs30,vs54,vs44"
+func_check +968  "xxlnand vs49,vs14,vs29"
+func_check +972  "xxleqv  vs62,vs22,vs30"
+func_check +976  "xscvdpspn vs60,vs54"
+func_check +980  "xsrsp   vs22,vs45"
+func_check +984  "xscvuxdsp vs26,vs59"
+func_check +988  "xscvsxdsp vs38,vs49"
+func_check +992  "xscvspdpn vs59,vs26"
+func_check +996  "fmrgow  f24,f14,f2"
+func_check +1000 "fmrgew  f22,f7,f5"
diff --git a/gdb/testsuite/gdb.arch/powerpc-power.s b/gdb/testsuite/gdb.arch/powerpc-power.s
index 14bfacc..759d4ba 100644
--- a/gdb/testsuite/gdb.arch/powerpc-power.s
+++ b/gdb/testsuite/gdb.arch/powerpc-power.s
@@ -134,3 +134,138 @@ func:
 	.long	0xfc020444	/* <+452>: ddivq   f0,f2,f0          */
 	.long	0xec820d04	/* <+456>: dcmpu   cr1,f2,f1         */
 	.long	0xfc820504	/* <+460>: dcmpuq  cr1,f2,f0         */
+	.long	0x7c05071d	/* <+464>: tabort. r5                */
+	.long	0x7ce8861d	/* <+468>: tabortwc. 7,r8,r16        */
+	.long	0x7e8b565d	/* <+472>: tabortdc. 20,r11,r10      */
+	.long	0x7e2a9e9d	/* <+476>: tabortwci. 17,r10,-13     */
+	.long	0x7fa3dedd	/* <+480>: tabortdci. 29,r3,-5       */
+	.long	0x7c00051d	/* <+484>: tbegin.                   */
+	.long	0x7f80059c	/* <+488>: tcheck  cr7               */
+	.long	0x7c00055d	/* <+492>: tend.                     */
+	.long	0x7e00055d	/* <+496>: tendall.                  */
+	.long	0x7c18075d	/* <+500>: treclaim. r24             */
+	.long	0x7c0007dd	/* <+504>: trechkpt.                 */
+	.long	0x7c0005dd	/* <+508>: tsuspend.                 */
+	.long	0x7c2005dd	/* <+512>: tresume.                  */
+	.long	0x4c000124	/* <+516>: rfebb                     */
+	.long	0x4c000924	/* <+520>: rfebb   1                 */
+	.long	0x4d950460	/* <+524>: bctar-  12,4*cr5+gt       */
+	.long	0x4c870461	/* <+528>: bctarl- 4,4*cr1+so        */
+	.long	0x4dac0460	/* <+532>: bctar+  12,4*cr3+lt       */
+	.long	0x4ca20461	/* <+536>: bctarl+ 4,eq              */
+	.long	0x4c880c60	/* <+540>: bctar   4,4*cr2+lt,1      */
+	.long	0x4c871461	/* <+544>: bctarl  4,4*cr1+so,2      */
+	.long	0x7c00003c	/* <+548>: waitasec                  */
+	.long	0x7c00411c	/* <+552>: msgsndp r8                */
+	.long	0x7c200126	/* <+556>: mtsle   1                 */
+	.long	0x7c00d95c	/* <+560>: msgclrp r27               */
+	.long	0x7d4a616d	/* <+564>: stqcx.  r10,r10,r12       */
+	.long	0x7f80396d	/* <+568>: stqcx.  r28,0,r7          */
+	.long	0x7f135a28	/* <+572>: lqarx   r24,r19,r11       */
+	.long	0x7ec05a28	/* <+576>: lqarx   r22,0,r11         */
+	.long	0x7e80325c	/* <+580>: mfbhrbe r20,6             */
+	.long	0x7fb18329	/* <+584>: pbt.    r29,r17,r16       */
+	.long	0x7dc03b29	/* <+588>: pbt.    r14,0,r7          */
+	.long	0x7c00035c	/* <+592>: clrbhrb                   */
+	.long	0x116a05ed	/* <+596>: vpermxor v11,v10,v0,v23   */
+	.long	0x1302393c	/* <+600>: vaddeuqm v24,v2,v7,v4     */
+	.long	0x114a40bd	/* <+604>: vaddecuq v10,v10,v8,v2    */
+	.long	0x10af44fe	/* <+608>: vsubeuqm v5,v15,v8,v19    */
+	.long	0x119f877f	/* <+612>: vsubecuq v12,v31,v16,v29  */
+	.long	0x129d6888	/* <+616>: vmulouw v20,v29,v13       */
+	.long	0x13a0d089	/* <+620>: vmuluwm v29,v0,v26        */
+	.long	0x1115e0c0	/* <+624>: vaddudm v8,v21,v28        */
+	.long	0x103a08c2	/* <+628>: vmaxud  v1,v26,v1         */
+	.long	0x128308c4	/* <+632>: vrld    v20,v3,v1         */
+	.long	0x109358c7	/* <+636>: vcmpequd v4,v19,v11       */
+	.long	0x12eef100	/* <+640>: vadduqm v23,v14,v30       */
+	.long	0x11086940	/* <+644>: vaddcuq v8,v8,v13         */
+	.long	0x139b2188	/* <+648>: vmulosw v28,v27,v4        */
+	.long	0x106421c2	/* <+652>: vmaxsd  v3,v4,v4          */
+	.long	0x1013aa88	/* <+656>: vmuleuw v0,v19,v21        */
+	.long	0x13149ac2	/* <+660>: vminud  v24,v20,v19       */
+	.long	0x101c7ac7	/* <+664>: vcmpgtud v0,v28,v15       */
+	.long	0x12a01388	/* <+668>: vmulesw v21,v0,v2         */
+	.long	0x113a4bc2	/* <+672>: vminsd  v9,v26,v9         */
+	.long	0x133d5bc4	/* <+676>: vsrad   v25,v29,v11       */
+	.long	0x117c5bc7	/* <+680>: vcmpgtsd v11,v28,v11      */
+	.long	0x10a8d601	/* <+684>: bcdadd. v5,v8,v26,1       */
+	.long	0x10836408	/* <+688>: vpmsumb v4,v3,v12         */
+	.long	0x135fae41	/* <+692>: bcdsub. v26,v31,v21,1     */
+	.long	0x10b18448	/* <+696>: vpmsumh v5,v17,v16        */
+	.long	0x12f1a44e	/* <+700>: vpkudum v23,v17,v20       */
+	.long	0x1315ec88	/* <+704>: vpmsumw v24,v21,v29       */
+	.long	0x11366cc8	/* <+708>: vpmsumd v9,v22,v13        */
+	.long	0x125394ce	/* <+712>: vpkudus v18,v19,v18       */
+	.long	0x13d0b500	/* <+716>: vsubuqm v30,v16,v22       */
+	.long	0x11cb3d08	/* <+720>: vcipher v14,v11,v7        */
+	.long	0x1142b509	/* <+724>: vcipherlast v10,v2,v22    */
+	.long	0x12e06d0c	/* <+728>: vgbbd   v23,v13           */
+	.long	0x12198540	/* <+732>: vsubcuq v16,v25,v16       */
+	.long	0x13e12d44	/* <+736>: vorc    v31,v1,v5         */
+	.long	0x1091fd48	/* <+740>: vncipher v4,v17,v31       */
+	.long	0x1302dd49	/* <+744>: vncipherlast v24,v2,v27   */
+	.long	0x12f5bd4c	/* <+748>: vbpermq v23,v21,v23       */
+	.long	0x13724d4e	/* <+752>: vpksdus v27,v18,v9        */
+	.long	0x137ddd84	/* <+756>: vnand   v27,v29,v27       */
+	.long	0x1273c5c4	/* <+760>: vsld    v19,v19,v24       */
+	.long	0x10ad05c8	/* <+764>: vsbox   v5,v13            */
+	.long	0x13233dce	/* <+768>: vpksdss v25,v3,v7         */
+	.long	0x138804c7	/* <+772>: vcmpequd. v28,v8,v0       */
+	.long	0x1340d64e	/* <+776>: vupkhsw v26,v26           */
+	.long	0x10a73682	/* <+780>: vshasigmaw v5,v7,0,6      */
+	.long	0x13957684	/* <+784>: veqv    v28,v21,v14       */
+	.long	0x10289e8c	/* <+788>: vmrgow  v1,v8,v19         */
+	.long	0x100a56c2	/* <+792>: vshasigmad v0,v10,0,10    */
+	.long	0x10bb76c4	/* <+796>: vsrd    v5,v27,v14        */
+	.long	0x11606ece	/* <+800>: vupklsw v11,v13           */
+	.long	0x11c08702	/* <+804>: vclzb   v14,v16           */
+	.long	0x1280df03	/* <+808>: vpopcntb v20,v27          */
+	.long	0x13805f42	/* <+812>: vclzh   v28,v11           */
+	.long	0x13004f43	/* <+816>: vpopcnth v24,v9           */
+	.long	0x1360ff82	/* <+820>: vclzw   v27,v31           */
+	.long	0x12209f83	/* <+824>: vpopcntw v17,v19          */
+	.long	0x1180efc2	/* <+828>: vclzd   v12,v29           */
+	.long	0x12e0b7c3	/* <+832>: vpopcntd v23,v22          */
+	.long	0x1314eec7	/* <+836>: vcmpgtud. v24,v20,v29     */
+	.long	0x1126dfc7	/* <+840>: vcmpgtsd. v9,v6,v27       */
+	.long	0x7fced019	/* <+844>: lxsiwzx vs62,r14,r26      */
+	.long	0x7d00c819	/* <+848>: lxsiwzx vs40,0,r25        */
+	.long	0x7f20d098	/* <+852>: lxsiwax vs25,0,r26        */
+	.long	0x7c601898	/* <+856>: lxsiwax vs3,0,r3          */
+	.long	0x7fcc0067	/* <+860>: mfvsrd  r12,vs62          */
+	.long	0x7d9400e6	/* <+864>: mffprwz r20,f12           */
+	.long	0x7dc97118	/* <+868>: stxsiwx vs14,r9,r14       */
+	.long	0x7ea04118	/* <+872>: stxsiwx vs21,0,r8         */
+	.long	0x7e0b0167	/* <+876>: mtvsrd  vs48,r11          */
+	.long	0x7ff701a7	/* <+880>: mtvrwa  v31,r23           */
+	.long	0x7e1a01e6	/* <+884>: mtfprwz f16,r26           */
+	.long	0x7db36c18	/* <+888>: lxsspx  vs13,r19,r13      */
+	.long	0x7e406c18	/* <+892>: lxsspx  vs18,0,r13        */
+	.long	0x7d622519	/* <+896>: stxsspx vs43,r2,r4        */
+	.long	0x7ee05d19	/* <+900>: stxsspx vs55,0,r11        */
+	.long	0xf2d0c805	/* <+904>: xsaddsp vs54,vs48,vs25    */
+	.long	0xf1d2080c	/* <+908>: xsmaddasp vs14,vs50,vs1   */
+	.long	0xf3565042	/* <+912>: xssubsp vs26,vs22,vs42    */
+	.long	0xf375a04e	/* <+916>: xsmaddmsp vs27,vs53,vs52  */
+	.long	0xf100d82a	/* <+920>: xsrsqrtesp vs8,vs59       */
+	.long	0xf180482e	/* <+924>: xssqrtsp vs12,vs41        */
+	.long	0xf32b0083	/* <+928>: xsmulsp vs57,vs11,vs32    */
+	.long	0xf0d4d089	/* <+932>: xsmsubasp vs38,vs20,vs26  */
+	.long	0xf35330c0	/* <+936>: xsdivsp vs26,vs19,vs6     */
+	.long	0xf065b8cf	/* <+940>: xsmsubmsp vs35,vs37,vs55  */
+	.long	0xf3604069	/* <+944>: xsresp  vs59,vs8          */
+	.long	0xf1810c0f	/* <+948>: xsnmaddasp vs44,vs33,vs33 */
+	.long	0xf23ef44c	/* <+952>: xsnmaddmsp vs17,vs62,vs30 */
+	.long	0xf2d4fc8d	/* <+956>: xsnmsubasp vs54,vs52,vs31 */
+	.long	0xf0a5d4cb	/* <+960>: xsnmsubmsp vs37,vs5,vs58  */
+	.long	0xf3d66556	/* <+964>: xxlorc  vs30,vs54,vs44    */
+	.long	0xf22eed91	/* <+968>: xxlnand vs49,vs14,vs29    */
+	.long	0xf3d6f5d1	/* <+972>: xxleqv  vs62,vs22,vs30    */
+	.long	0xf380b42f	/* <+976>: xscvdpspn vs60,vs54       */
+	.long	0xf2c06c66	/* <+980>: xsrsp   vs22,vs45         */
+	.long	0xf340dca2	/* <+984>: xscvuxdsp vs26,vs59       */
+	.long	0xf0c08ce3	/* <+988>: xscvsxdsp vs38,vs49       */
+	.long	0xf360d52d	/* <+992>: xscvspdpn vs59,vs26       */
+	.long	0xff0e168c	/* <+996>: fmrgow  f24,f14,f2        */
+	.long	0xfec72f8c	/* <+1000>: fmrgew  f22,f7,f5        */